-----------------------------------------------------------------------------------------------
-- Client Lua Script for RuneBuddy
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
require "CraftingLib"

-----------------------------------------------------------------------------------------------
--Up Values
-----------------------------------------------------------------------------------------------
local error, floor, ipairs, pairs, tostring = error, math.floor, ipairs, pairs, tostring
local strformat = string.format

-----------------------------------------------------------------------------------------------
-- Wildstar APIs
-----------------------------------------------------------------------------------------------
local Apollo, ApolloColor, ApolloTimer, ICCommLib, GameLib, CraftingLib = Apollo, ApolloColor, 
	ApolloTimer, ICCommLib, GameLib, CraftingLib

local Event_FireGenericEvent, Print = Event_FireGenericEvent, Print 

-----------------------------------------------------------------------------------------------
-- WTF Module Definition
-----------------------------------------------------------------------------------------------
local RuneBuddy = Apollo.GetPackage("Gemini:Addon-1.1").tPackage:NewAddon("RuneBuddy", false)

--Setup GeminiGUI
local GeminiGUI = Apollo.GetPackage("Gemini:GUI-1.0").tPackage

-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
local tMainFormDef = {
	AnchorOffsets = { 84, -3, 627, 807 },
	RelativeToClient = true, 
	BGColor = "UI_WindowBGDefault", 
	TextColor = "UI_WindowTextDefault", 
	Template = "Metal_Primary_Nav_Vendor", 
	Name = "MainForm", 
	Border = true, 
	Picture = true, 
	SwallowMouseClicks = true, 
	Moveable = true, 
	Escapable = true, 
	Overlapped = true, 
	UseTemplateBG = true, 
	Children = {
		{
			AnchorOffsets = { 89, 48, 213, 126 },
			Class = "Button", 
			Base = "BK3:btnMetal_TabMainLeft", 
			Font = "DefaultButton", 
			ButtonType = "Check", 
			RadioGroup = "GlyphOptions", 
			DT_VCENTER = true, 
			DT_CENTER = true, 
			BGColor = "UI_BtnBGDefault", 
			TextColor = "UI_BtnTextDefault", 
			NormalTextColor = "UI_BtnTextDefault", 
			PressedTextColor = "UI_BtnTextDefault", 
			FlybyTextColor = "UI_BtnTextDefault", 
			PressedFlybyTextColor = "UI_BtnTextDefault", 
			DisabledTextColor = "UI_BtnTextDefault", 
			Name = "btnMyGlyphs", 
			Text = "My Glyphs", 
			GlobalRadioGroup = "", 
			RelativeToClient = true, 
			Events = {
				ButtonSignal = "YourFunctionName",
			},
		},
		{
			AnchorOffsets = { 212, 48, 336, 126 },
			Class = "Button", 
			Base = "BK3:btnMetal_TabMainMid", 
			Font = "DefaultButton", 
			ButtonType = "Check", 
			RadioGroup = "GlyphOptions", 
			DT_VCENTER = true, 
			DT_CENTER = true, 
			BGColor = "UI_BtnBGDefault", 
			TextColor = "UI_BtnTextDefault", 
			NormalTextColor = "UI_BtnTextDefault", 
			PressedTextColor = "UI_BtnTextDefault", 
			FlybyTextColor = "UI_BtnTextDefault", 
			PressedFlybyTextColor = "UI_BtnTextDefault", 
			DisabledTextColor = "UI_BtnTextDefault", 
			Name = "btnMyGlyphSets", 
			Text = "My Glyph Sets", 
			GlobalRadioGroup = "", 
			RelativeToClient = true, 
			Events = {
				ButtonSignal = "YourFunctionName",
			},
		},
		{
			AnchorOffsets = { 335, 48, 484, 126 },
			Class = "Button", 
			Base = "BK3:btnMetal_TabMainRight", 
			Font = "DefaultButton", 
			ButtonType = "Check", 
			RadioGroup = "GlyphOptions", 
			DT_VCENTER = true, 
			DT_CENTER = true, 
			BGColor = "UI_BtnBGDefault", 
			TextColor = "UI_BtnTextDefault", 
			NormalTextColor = "UI_BtnTextDefault", 
			PressedTextColor = "UI_BtnTextDefault", 
			FlybyTextColor = "UI_BtnTextDefault", 
			PressedFlybyTextColor = "UI_BtnTextDefault", 
			DisabledTextColor = "UI_BtnTextDefault", 
			Name = "btnPossibleGlyphSets", 
			Text = "Possible Glyph Sets", 
			GlobalRadioGroup = "", 
			RelativeToClient = true, 
			Events = {
				ButtonSignal = "YourFunctionName",
			},
		},
		{
			AnchorOffsets = { -2, 139, 483, 783 },
			RelativeToClient = true, 
			BGColor = "UI_WindowBGDefault", 
			TextColor = "UI_WindowTextDefault", 
			Template = "CRB_Normal", 
			Name = "wndContentMyGlyphs", 
			Border = true, 
			IgnoreMouse = true, 
			UseTemplateBG = true, 
			Picture = true, 
			VScroll = true, 
			Children = {
				{
					AnchorOffsets = { -64, -70, -63, -79 },
					AnchorPoints = { 0.12846, 0.14796, 1.13834, 0.18537 },
					RelativeToClient = true, 
					BGColor = "UI_WindowBGDefault", 
					TextColor = "UI_WindowTextDefault", 
					Name = "Window", 
					Sprite = "AbilitiesSprites:spr_StatGreen", 
					Picture = true, 
					IgnoreMouse = true, 
					Pixies = {
						{ AnchorOffsets = { 50, 50, 100, 100 }, Sprite = "WhiteFill", BGColor = "white", TextColor = "black", },
					},
				},
				{
					AnchorOffsets = { 8, 0, 467, 27 },
					RelativeToClient = true, 
					Font = "CRB_Interface14_BBO", 
					Text = "Statistics", 
					BGColor = "UI_WindowBGDefault", 
					TextColor = "UI_WindowTextDefault", 
					Name = "stats_title", 
				},
				{
					AnchorOffsets = { 1, 32, 467, 207 },
					RelativeToClient = true, 
					BGColor = "UI_WindowBGDefault", 
					TextColor = "UI_WindowTextDefault", 
					Template = "CRB_Datachron", 
					Name = "wndstats", 
					Border = true, 
					UseTemplateBG = true, 
					Children = {
						{
							AnchorOffsets = { 11, 10, 51, 47 },
							RelativeToClient = true, 
							BGColor = "UI_WindowBGDefault", 
							TextColor = "UI_WindowTextDefault", 
							Name = "Fire", 
							Sprite = "Crafting_RunecraftingSprites:sprRunecrafting_Fire", 
							Picture = true, 
							IgnoreMouse = true, 
						},
						{
							AnchorOffsets = { 10, 46, 50, 83 },
							RelativeToClient = true, 
							BGColor = "UI_WindowBGDefault", 
							TextColor = "UI_WindowTextDefault", 
							Name = "Earth", 
							Sprite = "Crafting_RunecraftingSprites:sprRunecrafting_Earth", 
							Picture = true, 
							IgnoreMouse = true, 
						},
						{
							AnchorOffsets = { 10, 81, 50, 118 },
							RelativeToClient = true, 
							BGColor = "UI_WindowBGDefault", 
							TextColor = "UI_WindowTextDefault", 
							Name = "Water", 
							Sprite = "Crafting_RunecraftingSprites:sprRunecrafting_Water", 
							Picture = true, 
							IgnoreMouse = true, 
						},
						{
							AnchorOffsets = { 10, 112, 50, 149 },
							RelativeToClient = true, 
							BGColor = "UI_WindowBGDefault", 
							TextColor = "UI_WindowTextDefault", 
							Name = "Air", 
							Sprite = "Crafting_RunecraftingSprites:sprRunecrafting_Air", 
							Picture = true, 
							IgnoreMouse = true, 
						},
						{
							AnchorOffsets = { 415, 114, 455, 151 },
							RelativeToClient = true, 
							BGColor = "UI_WindowBGDefault", 
							TextColor = "UI_WindowTextDefault", 
							Name = "Life", 
							Sprite = "Crafting_RunecraftingSprites:sprRunecrafting_Life", 
							Picture = true, 
							IgnoreMouse = true, 
						},
						{
							AnchorOffsets = { 416, 79, 456, 116 },
							RelativeToClient = true, 
							BGColor = "UI_WindowBGDefault", 
							TextColor = "UI_WindowTextDefault", 
							Name = "Logic", 
							Sprite = "Crafting_RunecraftingSprites:sprRunecrafting_Logic", 
							Picture = true, 
							IgnoreMouse = true, 
						},
						{
							AnchorOffsets = { 416, 46, 456, 83 },
							RelativeToClient = true, 
							BGColor = "UI_WindowBGDefault", 
							TextColor = "UI_WindowTextDefault", 
							Name = "Fusion", 
							Sprite = "Crafting_RunecraftingSprites:sprRunecrafting_Fusion", 
							Picture = true, 
							IgnoreMouse = true, 
						},
						{
							AnchorOffsets = { 416, 11, 456, 48 },
							RelativeToClient = true, 
							BGColor = "UI_WindowBGDefault", 
							TextColor = "UI_WindowTextDefault", 
							Name = "Omni", 
							Sprite = "Crafting_RunecraftingSprites:sprRunecrafting_Omni", 
							Picture = true, 
							IgnoreMouse = true, 
						},
						{
							AnchorOffsets = { 51, 14, 91, 47 },
							RelativeToClient = true, 
							BGColor = "UI_WindowBGDefault", 
							TextColor = "UI_WindowTextDefault", 
							Name = "numFire", 
							DT_CENTER = true, 
							DT_VCENTER = true, 
						},
						{
							AnchorOffsets = { 52, 49, 92, 81 },
							RelativeToClient = true, 
							BGColor = "UI_WindowBGDefault", 
							TextColor = "UI_WindowTextDefault", 
							Name = "numEarth", 
							DT_CENTER = true, 
							DT_VCENTER = true, 
						},
						{
							AnchorOffsets = { 52, 87, 92, 116 },
							RelativeToClient = true, 
							BGColor = "UI_WindowBGDefault", 
							TextColor = "UI_WindowTextDefault", 
							Name = "numWater", 
							DT_CENTER = true, 
							DT_VCENTER = true, 
						},
						{
							AnchorOffsets = { 52, 116, 92, 146 },
							RelativeToClient = true, 
							BGColor = "UI_WindowBGDefault", 
							TextColor = "UI_WindowTextDefault", 
							Name = "numAir", 
							DT_CENTER = true, 
							DT_VCENTER = true, 
						},
						{
							AnchorOffsets = { 371, 16, 411, 45 },
							RelativeToClient = true, 
							BGColor = "UI_WindowBGDefault", 
							TextColor = "UI_WindowTextDefault", 
							Name = "numOmni", 
							DT_CENTER = true, 
							DT_VCENTER = true, 
						},
						{
							AnchorOffsets = { 372, 50, 412, 79 },
							RelativeToClient = true, 
							BGColor = "UI_WindowBGDefault", 
							TextColor = "UI_WindowTextDefault", 
							Name = "numFusion", 
							DT_CENTER = true, 
							DT_VCENTER = true, 
						},
						{
							AnchorOffsets = { 373, 84, 413, 112 },
							RelativeToClient = true, 
							BGColor = "UI_WindowBGDefault", 
							TextColor = "UI_WindowTextDefault", 
							Name = "numLogic", 
							DT_CENTER = true, 
							DT_VCENTER = true, 
						},
						{
							AnchorOffsets = { 373, 119, 413, 147 },
							RelativeToClient = true, 
							BGColor = "UI_WindowBGDefault", 
							TextColor = "UI_WindowTextDefault", 
							Name = "numLife", 
							DT_CENTER = true, 
							DT_VCENTER = true, 
						},
						{
							AnchorOffsets = { -3, -5, 464, 22 },
							RelativeToClient = true, 
							Font = "CRB_Interface12_BBO", 
							Text = "Total Runes", 
							BGColor = "UI_WindowBGDefault", 
							TextColor = "UI_WindowTextDefault", 
							Name = "title", 
							DT_CENTER = true, 
							DT_VCENTER = true, 
						},
					},
				},
				{
					AnchorOffsets = { 1, 212, 466, 773 },
					RelativeToClient = true, 
					BGColor = "UI_WindowBGDefault", 
					TextColor = "UI_WindowTextDefault", 
					Template = "CRB_Datachron", 
					Name = "Window2", 
					Border = true, 
					UseTemplateBG = true, 
					Children = {
						{
							AnchorOffsets = { -3, -3, 236, 25 },
							RelativeToClient = true, 
							Font = "CRB_Interface12_BBO", 
							Text = "Rune Slots On You Gear", 
							BGColor = "UI_WindowBGDefault", 
							TextColor = "UI_WindowTextDefault", 
							Name = "Window", 
							DT_CENTER = true, 
						},
						{
							AnchorOffsets = { 0, 19, 459, 475 },
							Class = "TreeControl", 
							RelativeToClient = true, 
							BGColor = "UI_WindowBGDefault", 
							TextColor = "UI_WindowTextDefault", 
							Name = "TreeControl", 
						},
					},
				},
			},
		},
		{
			AnchorOffsets = { -17, 19, 497, 57 },
			RelativeToClient = true, 
			Font = "CRB_Header16_O", 
			Text = "RuneBuddy", 
			BGColor = "UI_WindowBGDefault", 
			TextColor = "UI_WindowTextDefault", 
			Name = "Window", 
			DT_VCENTER = true, 
			DT_CENTER = true, 
		},
		{
			AnchorOffsets = { 497, 14, 529, 46 },
			Class = "Button", 
			Base = "AbilitiesSprites:btn_Close", 
			Font = "DefaultButton", 
			ButtonType = "PushButton", 
			DT_VCENTER = true, 
			DT_CENTER = true, 
			BGColor = "UI_BtnBGDefault", 
			TextColor = "UI_BtnTextDefault", 
			NormalTextColor = "UI_BtnTextDefault", 
			PressedTextColor = "UI_BtnTextDefault", 
			FlybyTextColor = "UI_BtnTextDefault", 
			PressedFlybyTextColor = "UI_BtnTextDefault", 
			DisabledTextColor = "UI_BtnTextDefault", 
			Name = "Button", 
			Events = {
				ButtonSignal = "OnCancel",
			},
		},
	},
}



local tMainForm
local wndMainForm

-----------------------------------------------------------------------------------------------
-- RuneBuddy OnInitialize
-----------------------------------------------------------------------------------------------
function RuneBuddy:OnInitialize()
	--Window Defs
	tMainForm = GeminiGUI:Create(tMainFormDef)
end

-----------------------------------------------------------------------------------------------
-- RuneBuddy OnDocLoaded
-----------------------------------------------------------------------------------------------
function RuneBuddy:OnEnable()
	--Slash Commands
	Apollo.RegisterSlashCommand("rb", "OnRuneBuddyOn", self)

	--Event Handlers
	Apollo.RegisterEventHandler("WindowManagementReady", "OnWindowManageMentReady", self)
	-- Do additional Addon initialization here
end

-----------------------------------------------------------------------------------------------
-- RuneBuddy Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

-- on SlashCommand "/rb"
function RuneBuddy:OnRuneBuddyOn()
	wndMainForm = tMainForm:GetInstance()
	self.GetGear()
end

function RuneBuddy:GetGear()
	local TreeList = wndMainForm:FindChild("TreeControl")
	local tGearEquiped = {}
	local Status
	local GlyphSlots = {}
	local GearNode
	local tGlyphInfo = {}
	local GlyphIcon
	local GlyphName
	local SlotCountEquiped = {Fire=0,Air=0,Earth=0,Fusion=0,Logic=0,Water=0,Life=0,Omni=0 }

	tGearEquiped = CraftingLib.GetValidGlyphableItems(true, false)
	if not tGearEquiped then
		return
	end
	Event_FireGenericEvent("SendVarToRover","GearList", tGearEquiped, 0)

	local equipNode = TreeList:AddNode(0, "Equiped Gear")

	for k, v in pairs(tGearEquiped) do
		GearNode = TreeList:AddNode(equipNode, v:GetName())

		--get glyph table
		GlyphSlots = v:GetSigils().arSigils

Event_FireGenericEvent("SendVarToRover","GlyphSlots", GlyphSlots, 0)

		for i=1, #GlyphSlots do
			--Get Icon for later use.
			-- GlyphIcon = GlyphSlots[i].itemGlyph:GetIcon()           
			
			--check for rune status - Locked, Open, or a rune
			if GlyphSlots[i].bUnlocked == true and not GlyphSlots[i].itemGlyph then                
				Status = "Open"
			elseif GlyphSlots[i].bUnlocked == false and not GlyphSlots[i].itemGlyph then
				Status = "Locked"
			elseif GlyphSlots[i].itemGlyph then
				Status = GlyphSlots[i].itemGlyph:GetName()
			else
				Status = ""
			end

			TreeList:AddNode(GearNode, GlyphSlots[i].strName .. " - " .. Status)
			TreeList:CollapseNode(GearNode)
			SlotCountEquiped[GlyphSlots[i].strName] = SlotCountEquiped[GlyphSlots[i].strName] + 1

			--Event_FireGenericEvent("SendVarToRover", "SlotCountEquiped", SlotCountEquiped, 0)

			for k, v in pairs(SlotCountEquiped) do
				if k == GlyphSlots[i].strName then
					local wnd = wndMainForm:FindChild("num"..GlyphSlots[i].strName)
					wnd:SetText(v)
				end
			end
		end
	end
end


-----------------------------------------------------------------------------------------------
-- RuneBuddyForm Functions
-----------------------------------------------------------------------------------------------
-- when the OK button is clicked
function RuneBuddy:OnOK()
	self.wndMain:Close() -- hide the window
end

-- when the Cancel button is clicked
function RuneBuddy:OnCancel()
	wndMainForm:show(false) -- hide the window
end
