--
-- Created by IntelliJ IDEA.
-- User: Micheal
-- Date: 8/12/2014
-- Time: 11:41 PM
-- To change this template use File | Settings | File Templates.
--

-- Set a reference to the actual package or create an empty table
local Lib = Apollo.GetPackage("GuiDefs") and Apollo.GetPackage("GuiDefs").tPackage or {}

--Up Values
local tinsert, pairs, ipairs = table.insert, pairs, ipairs
local next, select, strmatch, dlocal = next, select, string.match, debug.getlocal

-- Wildstar APIs
local Apollo = Apollo
local Event_FireGenericEvent = Event_FireGenericEvent

local tWindowDefs = {
    tMainFormDef = {
      AnchorOffsets = { 49, 0, 643, 810 },
      RelativeToClient = true,
      BGColor = "UI_WindowBGDefault",
      TextColor = "UI_WindowTextDefault",
      Template = "Metal_Primary_Nav_SubNav",
      Name = "MainForm",
      Border = true,
      Picture = true,
      SwallowMouseClicks = true,
      Moveable = true,
      Escapable = true,
      Overlapped = true,
      UseTemplateBG = true,
      Children = {
        {
          AnchorOffsets = { 26, 48, 150, 126 },
          Class = "Button",
          Base = "BK3:btnMetal_TabMainLeft",
          Font = "DefaultButton",
          ButtonType = "Check",
          RadioGroup = "GlyphOptions",
          DT_VCENTER = true,
          DT_CENTER = true,
          BGColor = "UI_BtnBGDefault",
          TextColor = "UI_BtnTextDefault",
          NormalTextColor = "UI_BtnTextDefault",
          PressedTextColor = "UI_BtnTextDefault",
          FlybyTextColor = "UI_BtnTextDefault",
          PressedFlybyTextColor = "UI_BtnTextDefault",
          DisabledTextColor = "UI_BtnTextDefault",
          Name = "btnMyGlyphs",
          Text = "My Glyphs",
          GlobalRadioGroup = "",
          Events = {
            ButtonSignal = "YourFunctionName",
          },
        },
        {
          AnchorOffsets = { 230, 48, 354, 126 },
          Class = "Button",
          Base = "BK3:btnMetal_TabMainMid",
          Font = "DefaultButton",
          ButtonType = "Check",
          RadioGroup = "GlyphOptions",
          DT_VCENTER = true,
          DT_CENTER = true,
          BGColor = "UI_BtnBGDefault",
          TextColor = "UI_BtnTextDefault",
          NormalTextColor = "UI_BtnTextDefault",
          PressedTextColor = "UI_BtnTextDefault",
          FlybyTextColor = "UI_BtnTextDefault",
          PressedFlybyTextColor = "UI_BtnTextDefault",
          DisabledTextColor = "UI_BtnTextDefault",
          Name = "btnMyGlyphSets",
          Text = "My Glyph Sets",
          GlobalRadioGroup = "",
          Events = {
            ButtonSignal = "YourFunctionName",
          },
        },
        {
          AnchorOffsets = { 419, 49, 568, 127 },
          Class = "Button",
          Base = "BK3:btnMetal_TabMainRight",
          Font = "DefaultButton",
          ButtonType = "Check",
          RadioGroup = "GlyphOptions",
          DT_VCENTER = true,
          DT_CENTER = true,
          BGColor = "UI_BtnBGDefault",
          TextColor = "UI_BtnTextDefault",
          NormalTextColor = "UI_BtnTextDefault",
          PressedTextColor = "UI_BtnTextDefault",
          FlybyTextColor = "UI_BtnTextDefault",
          PressedFlybyTextColor = "UI_BtnTextDefault",
          DisabledTextColor = "UI_BtnTextDefault",
          Name = "btnPossibleGlyphSets",
          Text = "Possible Glyph Sets",
          GlobalRadioGroup = "",
          Events = {
            ButtonSignal = "YourFunctionName",
          },
        },
        {
          AnchorOffsets = { -2, 179, 535, 783 },
          RelativeToClient = true,
          BGColor = "UI_WindowBGDefault",
          TextColor = "UI_WindowTextDefault",
          Template = "CRB_Normal",
          Name = "wndContentMyGlyphs",
          Border = true,
          IgnoreMouse = true,
          UseTemplateBG = true,
          Picture = true,
          VScroll = true,
          Children = {
            {
              AnchorOffsets = { -73, -69, -73, -79 },
              AnchorPoints = { 0.12846, 0.14796, 1.13834, 0.18537 },
              RelativeToClient = true,
              BGColor = "UI_WindowBGDefault",
              TextColor = "UI_WindowTextDefault",
              Name = "Window",
              Sprite = "AbilitiesSprites:spr_StatGreen",
              Picture = true,
              IgnoreMouse = true,
            },
            {
              AnchorOffsets = { -2, -2, 506, 25 },
              RelativeToClient = true,
              Font = "CRB_Interface14_BBO",
              Text = "Statistics",
              BGColor = "UI_WindowBGDefault",
              TextColor = "UI_WindowTextDefault",
              Name = "Window1",
            },
            {
              AnchorOffsets = { 1, 32, 501, 207 },
              RelativeToClient = true,
              BGColor = "UI_WindowBGDefault",
              TextColor = "UI_WindowTextDefault",
              Template = "CRB_Datachron",
              Name = "wndstats",
              Border = true,
              UseTemplateBG = true,
              Children = {
                {
                  AnchorOffsets = { 11, 10, 51, 47 },
                  RelativeToClient = true,
                  BGColor = "UI_WindowBGDefault",
                  TextColor = "UI_WindowTextDefault",
                  Name = "Fire",
                  Sprite = "Crafting_RunecraftingSprites:sprRunecrafting_Fire",
                  Picture = true,
                  IgnoreMouse = true,
                },
                {
                  AnchorOffsets = { 10, 46, 50, 83 },
                  RelativeToClient = true,
                  BGColor = "UI_WindowBGDefault",
                  TextColor = "UI_WindowTextDefault",
                  Name = "Earth",
                  Sprite = "Crafting_RunecraftingSprites:sprRunecrafting_Earth",
                  Picture = true,
                  IgnoreMouse = true,
                },
                {
                  AnchorOffsets = { 10, 81, 50, 118 },
                  RelativeToClient = true,
                  BGColor = "UI_WindowBGDefault",
                  TextColor = "UI_WindowTextDefault",
                  Name = "Water",
                  Sprite = "Crafting_RunecraftingSprites:sprRunecrafting_Water",
                  Picture = true,
                  IgnoreMouse = true,
                },
                {
                  AnchorOffsets = { 10, 112, 50, 149 },
                  RelativeToClient = true,
                  BGColor = "UI_WindowBGDefault",
                  TextColor = "UI_WindowTextDefault",
                  Name = "Air",
                  Sprite = "Crafting_RunecraftingSprites:sprRunecrafting_Air",
                  Picture = true,
                  IgnoreMouse = true,
                },
                {
                  AnchorOffsets = { 441, 114, 481, 151 },
                  RelativeToClient = true,
                  BGColor = "UI_WindowBGDefault",
                  TextColor = "UI_WindowTextDefault",
                  Name = "Life",
                  Sprite = "Crafting_RunecraftingSprites:sprRunecrafting_Life",
                  Picture = true,
                  IgnoreMouse = true,
                },
                {
                  AnchorOffsets = { 441, 79, 481, 116 },
                  RelativeToClient = true,
                  BGColor = "UI_WindowBGDefault",
                  TextColor = "UI_WindowTextDefault",
                  Name = "Logic",
                  Sprite = "Crafting_RunecraftingSprites:sprRunecrafting_Logic",
                  Picture = true,
                  IgnoreMouse = true,
                },
                {
                  AnchorOffsets = { 441, 46, 481, 83 },
                  RelativeToClient = true,
                  BGColor = "UI_WindowBGDefault",
                  TextColor = "UI_WindowTextDefault",
                  Name = "Fusion",
                  Sprite = "Crafting_RunecraftingSprites:sprRunecrafting_Fusion",
                  Picture = true,
                  IgnoreMouse = true,
                },
                {
                  AnchorOffsets = { 441, 11, 481, 48 },
                  RelativeToClient = true,
                  BGColor = "UI_WindowBGDefault",
                  TextColor = "UI_WindowTextDefault",
                  Name = "Omni",
                  Sprite = "Crafting_RunecraftingSprites:sprRunecrafting_Omni",
                  Picture = true,
                  IgnoreMouse = true,
                },
                {
                  AnchorOffsets = { 51, 14, 91, 47 },
                  RelativeToClient = true,
                  BGColor = "UI_WindowBGDefault",
                  TextColor = "UI_WindowTextDefault",
                  Name = "numFire",
                  DT_CENTER = true,
                  DT_VCENTER = true,
                },
                {
                  AnchorOffsets = { 52, 49, 92, 81 },
                  RelativeToClient = true,
                  BGColor = "UI_WindowBGDefault",
                  TextColor = "UI_WindowTextDefault",
                  Name = "numEarth",
                  DT_CENTER = true,
                  DT_VCENTER = true,
                },
                {
                  AnchorOffsets = { 52, 87, 92, 116 },
                  RelativeToClient = true,
                  BGColor = "UI_WindowBGDefault",
                  TextColor = "UI_WindowTextDefault",
                  Name = "numWater",
                  DT_CENTER = true,
                  DT_VCENTER = true,
                },
                {
                  AnchorOffsets = { 52, 116, 92, 146 },
                  RelativeToClient = true,
                  BGColor = "UI_WindowBGDefault",
                  TextColor = "UI_WindowTextDefault",
                  Name = "numAir",
                  DT_CENTER = true,
                  DT_VCENTER = true,
                },
                {
                  AnchorOffsets = { 396, 16, 436, 45 },
                  RelativeToClient = true,
                  BGColor = "UI_WindowBGDefault",
                  TextColor = "UI_WindowTextDefault",
                  Name = "numOmni",
                  DT_CENTER = true,
                  DT_VCENTER = true,
                },
                {
                  AnchorOffsets = { 397, 50, 437, 79 },
                  RelativeToClient = true,
                  BGColor = "UI_WindowBGDefault",
                  TextColor = "UI_WindowTextDefault",
                  Name = "numFusion",
                  DT_CENTER = true,
                  DT_VCENTER = true,
                },
                {
                  AnchorOffsets = { 398, 84, 438, 112 },
                  RelativeToClient = true,
                  BGColor = "UI_WindowBGDefault",
                  TextColor = "UI_WindowTextDefault",
                  Name = "numLogic",
                  DT_CENTER = true,
                  DT_VCENTER = true,
                },
                {
                  AnchorOffsets = { 398, 119, 438, 147 },
                  RelativeToClient = true,
                  BGColor = "UI_WindowBGDefault",
                  TextColor = "UI_WindowTextDefault",
                  Name = "numLife",
                  DT_CENTER = true,
                  DT_VCENTER = true,
                },
                {
                  AnchorOffsets = { -3, -5, 499, 22 },
                  RelativeToClient = true,
                  Font = "CRB_Interface12_BBO",
                  Text = "Total Runes",
                  BGColor = "UI_WindowBGDefault",
                  TextColor = "UI_WindowTextDefault",
                  Name = "Window",
                  DT_CENTER = true,
                  DT_VCENTER = true,
                },
              },
            },
            {
              AnchorOffsets = { 1, 212, 239, 662 },
              RelativeToClient = true,
              BGColor = "UI_WindowBGDefault",
              TextColor = "UI_WindowTextDefault",
              Template = "CRB_Datachron",
              Name = "Window2",
              Border = true,
              UseTemplateBG = true,
              Children = {
                {
                  AnchorOffsets = { -3, -3, 236, 25 },
                  RelativeToClient = true,
                  Font = "CRB_Interface12_BBO",
                  Text = "Rune Slots On You Gear",
                  BGColor = "UI_WindowBGDefault",
                  TextColor = "UI_WindowTextDefault",
                  Name = "Window",
                  DT_CENTER = true,
                },
              },
            },
          },
        },
      },
    }
}

function GuiDefs:OnInitialize()
  Event_FireGenericEvent("SendVarToRover", "Window Defs", tWindowDefs)
end

function GuiDefs:OnEnable()
  self.GetDefs()
end

function GeminiGuiTableDefs:GetDefs()
  return tWindowDefs
end
